## forkstat 0.01.04

=== Makefile ===
VERSION=0.01.04
#
# Version "Freaky Fork Finder"
#

CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"'

BINDIR=/usr/bin
MANDIR=/usr/share/man/man8

forkstat: forkstat.o
	$(CC) $(CFLAGS) $< -o $@ $(LDFLAGS)

forkstat.8.gz: forkstat.8
	gzip -c $< > $@

dist:
	rm -rf forkstat-$(VERSION)
	mkdir forkstat-$(VERSION)
	cp Makefile forkstat.c forkstat.8 forkstat-$(VERSION)
	tar -zcf forkstat-$(VERSION).tar.gz forkstat-$(VERSION)
	rm -rf forkstat-$(VERSION)

clean:
	rm -f forkstat forkstat.o forkstat.8.gz
	rm -f forkstat-$(VERSION).tar.gz

install: forkstat forkstat.8.gz
	mkdir -p ${DESTDIR}${BINDIR}
	cp forkstat ${DESTDIR}${BINDIR}
	mkdir -p ${DESTDIR}${MANDIR}
	cp forkstat.8.gz ${DESTDIR}${MANDIR}

=== debian/changelog ===
forkstat (0.01.04-1) unstable; urgency=low

  * Makefile: bump version
  * Forgot to add -q option to mini help
  * Add -q option to run quietly while gathering stats
  * Ensure we have null at end of cmdline buffer
  * Update mini help info
  * Add -D option to specify duration of forkstat run
  * Add -S statistics option
  * comm should be checking the comm field and not the coredump field
  * Add comm and core dump event handling and -e option
  * Remove need to link with math library
  * Fix proc names such as /sbin/init which were being truncated
  * More optimal short cmdline truncation

 -- Colin King <colin.king@canonical.com>  Wed, 19 Mar 2014 17:46:51 +0000

forkstat (0.01.03-1) unstable; urgency=low

  * Makefile: bump version again
  * Makefile: improve make dist, don't use git

 -- Colin King <colin.king@canonical.com>  Mon, 17 Mar 2014 19:32:11 +0000

forkstat (0.01.02-1) unstable; urgency=low

  * Makefile: bump version
  * Correct debian copyright, set to GPL-2+

 -- Colin King <colin.king@canonical.com>  Mon, 17 Mar 2014 18:57:22 +0000

forkstat (0.01.01-1) unstable; urgency=low

  * Initial Debian release (Closes: #741926)
  * Make debian/rules executable
  * Makefile: bump version
  * Minor fix to man page
  * Add more info about process naming in man page
  * Add kernel thread detection
  * Make print_heading static
  * Change "Command" to "Process" to show process name
  * Remove redundant select and fix error handling on netlink connect
  * Fix fd lead on comm field read
  * Fix gcc warning on older versions of gcc

 -- Colin King <colin.king@canonical.com>  Mon, 17 Mar 2014 10:53:31 +0000

forkstat (0.01.00-1) unstable; urgency=low

  * Initial release

 -- Colin King <colin.king@canonical.com>  Sun, 16 Mar 2014 19:12:11 +0000

=== debian/control ===
Source: forkstat
Section: admin
Priority: optional
Maintainer: Colin King <colin.king@canonical.com>
Uploaders: Kamal Mostafa <kamal@whence.com>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 7)
Homepage: http://kernel.ubuntu.com/~cking/forkstat

Package: forkstat
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: process fork/exec/exit monitoring tool
 Forkstat monitors process fork(), exec() and exit() activity.
 It is useful for monitoring system behaviour and to track down
 rogue processes that are spawning off processes and potentially
 abusing the system.

## forkstat 0.01.08

=== Makefile ===
--- 
+++ 
@@ -1,15 +1,17 @@
-VERSION=0.01.04
+VERSION=0.01.08
 #
-# Version "Freaky Fork Finder"
+# Version "Frantic Forking Finder"
 #
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"'
+
+export DEB_BUILD_HARDENING=1
 
 BINDIR=/usr/bin
 MANDIR=/usr/share/man/man8
 
 forkstat: forkstat.o
-	$(CC) $(CFLAGS) $< -o $@ $(LDFLAGS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $< -o $@ $(LDFLAGS)
 
 forkstat.8.gz: forkstat.8
 	gzip -c $< > $@

=== debian/changelog ===
forkstat (0.01.08-1) unstable; urgency=medium

  * Add deb build hardening
  * Makefile: bump version
  * Handle -ENOBUFS on recv, this is not a terminal error
  * fix up man page, minor changes to formatting

 -- Colin King <colin.king@canonical.com>  Thu, 3 Jul 2014 13:42:00 +0100

forkstat (0.01.07-1) unstable; urgency=medium

  * Malefile: bump version again
  * Reference comm field and not coredump field in COMM event

 -- Colin King <colin.king@canonical.com>  Thu, 22 May 2014 18:49:22 +0100

forkstat (0.01.06-1) unstable; urgency=medium

  * Makefile: bump version
  * Clean up code, add some more comments
  * Check for different proc connector support against kernel versions

 -- Colin King <colin.king@canonical.com>  Thu, 22 May 2014 18:24:11 +0100

forkstat (0.01.05-1) unstable; urgency=low

  * Makefile; bump version
  * Use strtol rather than atoi to avoid any number parsing overflows or errors
  * Minor clean up of man page

 -- Colin King <colin.king@canonical.com>  Sun, 18 May 2014 23:45:54 +0100

## forkstat 0.01.09

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.01.08
+VERSION=0.01.09
 #
 # Version "Frantic Forking Finder"
 #

=== debian/changelog ===
forkstat (0.01.09-1) unstable; urgency=medium

  * Makefile: bump version
  * Fix spin loop on stats list, add more exit points on signal
  * Remove siginterrupt
  * Debian: update standards version
  * Add better signal handling
  * Handle gettimeofday failures
  * Handle time() errors
  * Handle -ve differences in totals
  * Improve error reporting
  * Ignore returns from close(), fclose()
  * Remove trailing . from forkstat man page title

 -- Colin King <colin.king@canonical.com>  Fri, 19 Dec 2014 15:19:00 +0000

## forkstat 0.01.11

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,22 @@
-VERSION=0.01.09
+#
+# Copyright (C) 2014-2015 Canonical, Ltd.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+#
+
+VERSION=0.01.11
 #
 # Version "Frantic Forking Finder"
 #
@@ -19,7 +37,7 @@
 dist:
 	rm -rf forkstat-$(VERSION)
 	mkdir forkstat-$(VERSION)
-	cp Makefile forkstat.c forkstat.8 forkstat-$(VERSION)
+	cp -rp Makefile forkstat.c forkstat.8 mascot forkstat-$(VERSION)
 	tar -zcf forkstat-$(VERSION).tar.gz forkstat-$(VERSION)
 	rm -rf forkstat-$(VERSION)

=== debian/changelog ===
forkstat (0.01.11-1) unstable; urgency=medium

  * Makefile: bump version
  * Try to run at high priority to capture fast activity
  * Print "fork" or "clone" depending on what we deduced
  * Add detection of thread creation rather

 -- Colin King <colin.king@canonical.com>  Tue, 9 Jun 2015 19:15:00 +0100

forkstat (0.01.10-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: add mascot in make dist rule
  * Cleanup variable warnings with different values of LINUX_VERSION_CODE
  * Make a few more functions static, somehow overlooked these
  * Remove sig handling on SIGILL, SIGABRT, SIGBUS
  * Reduce scope of variable len (fixes cppcheck style warning)
  * Manual: update copyright info and date
  * forkstat.c: update copyright year
  * Makefile: Add copyright
  * Add in forkstat svg mascot

 -- Colin King <colin.king@canonical.com>  Mon, 18 May 2015 15:31:00 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
 Uploaders: Kamal Mostafa <kamal@whence.com>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 7)
 Homepage: http://kernel.ubuntu.com/~cking/forkstat

## forkstat 0.01.13

=== Makefile ===
--- 
+++ 
@@ -16,12 +16,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.01.11
+VERSION=0.01.13
 #
 # Version "Frantic Forking Finder"
 #
 
-CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"'
+CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
 
 export DEB_BUILD_HARDENING=1
 
@@ -37,7 +37,8 @@
 dist:
 	rm -rf forkstat-$(VERSION)
 	mkdir forkstat-$(VERSION)
-	cp -rp Makefile forkstat.c forkstat.8 mascot forkstat-$(VERSION)
+	cp -rp Makefile forkstat.c forkstat.8 mascot COPYING \
+		forkstat-$(VERSION)
 	tar -zcf forkstat-$(VERSION).tar.gz forkstat-$(VERSION)
 	rm -rf forkstat-$(VERSION)

=== debian/changelog ===
forkstat (0.01.13-1) unstable; urgency=medium

  * Makefile: bump version
  * Add in OPT_EV_CLNE events if event mask not specified
  * Debian: control: update dephelper to >= 9
  * Debian: update compat to 9
  * Add -e clone option to trace thread cloning
  * Ensure hash is unsigned, otherwise we get -ve hash

 -- Colin King <colin.king@canonical.com>  Mon, 30 Nov 2015 13:01:02 +0000

forkstat (0.01.12-1) unstable; urgency=medium

  * Makefile: bump version
  * Add COPYING file to make dist
  * Makefile: default to -O2
  * Use strrok instead of strtok_r
  * Add COPYING file
  * Move next ptrs in structs to top to reduce cache thrashing
  * Use more efficient hash function

 -- Colin King <colin.king@canonical.com>  Thu, 12 Nov 2015 10:04:00 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Colin King <colin.king@canonical.com>
 Uploaders: Kamal Mostafa <kamal@whence.com>
 Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 7)
+Build-Depends: debhelper (>= 9)
 Homepage: http://kernel.ubuntu.com/~cking/forkstat
 
 Package: forkstat

=== debian/watch ===
version=3
http://kernel.ubuntu.com/~cking/tarballs/forkstat/forkstat-(.+).tar.gz

## forkstat 0.01.14

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2014-2015 Canonical, Ltd.
+# Copyright (C) 2014-2016 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.01.13
+VERSION=0.01.14
 #
 # Version "Frantic Forking Finder"
 #

=== debian/changelog ===
forkstat (0.01.14-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: update Standards-Version to 3.9.8
  * debian/rules: make build reproducable (Closes: #833439)
  * Update copyright year to 2016

 -- Colin King <colin.king@canonical.com>  Thu, 11 Aug 2016 10:06:44 +0100

## forkstat 0.01.16

=== Makefile ===
--- 
+++ 
@@ -16,12 +16,21 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.01.14
+VERSION=0.01.16
 #
 # Version "Frantic Forking Finder"
 #
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
+#
+# Pedantic flags
+#
+ifeq ($(PEDANTIC),1)
+CFLAGS += -Wabi -Wcast-qual -Wfloat-equal -Wmissing-declarations \
+	-Wmissing-format-attribute -Wno-long-long -Wpacked \
+	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
+	-Wno-missing-braces -Wno-sign-compare -Wno-multichar
+endif
 
 export DEB_BUILD_HARDENING=1

=== debian/changelog ===
forkstat (0.01.16-1) unstable; urgency=medium

  * Makefile: bump version
  * Make kernel_tasks const
  * unconstify arg in parse_ev to fix pedantic build warning
  * Clean up formatting on ev_map table
  * constify s1 and s2
  * Makefile: add PEDANTIC build flags

 -- Colin King <colin.king@canonical.com>  Mon, 7 Nov 2016 14:14:14 +0100

forkstat (0.01.15-1) unstable; urgency=medium

  * Makefile: bump version
  * forkstat: make counters size_t
  * forkstat: voidify return from fclose
  * Debian: fix spelling mistake in changelog

 -- Colin King <colin.king@canonical.com>  Thu, 6 Oct 2016 10:24:19 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
 Uploaders: Kamal Mostafa <kamal@whence.com>
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9)
 Homepage: http://kernel.ubuntu.com/~cking/forkstat

## forkstat 0.02.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2014-2016 Canonical, Ltd.
+# Copyright (C) 2014-2017 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -16,9 +16,9 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.01.16
+VERSION=0.02.00
 #
-# Version "Frantic Forking Finder"
+# Version "Perspicacious Process Peeker"
 #
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
@@ -43,18 +43,26 @@
 forkstat.8.gz: forkstat.8
 	gzip -c $< > $@
 
+.PHONEY: dist
 dist:
 	rm -rf forkstat-$(VERSION)
 	mkdir forkstat-$(VERSION)
 	cp -rp Makefile forkstat.c forkstat.8 mascot COPYING \
-		forkstat-$(VERSION)
+		snapcraft forkstat-$(VERSION)
 	tar -zcf forkstat-$(VERSION).tar.gz forkstat-$(VERSION)
 	rm -rf forkstat-$(VERSION)
 
+.PHONEY: pdf
+pdf:
+	man -t ./forkstat.8 | ps2pdf - > forkstat.pdf
+
+.PHONEY: clean
 clean:
 	rm -f forkstat forkstat.o forkstat.8.gz
 	rm -f forkstat-$(VERSION).tar.gz
+	rm -f forkstat.pdf
 
+.PHONEY: install
 install: forkstat forkstat.8.gz
 	mkdir -p ${DESTDIR}${BINDIR}
 	cp forkstat ${DESTDIR}${BINDIR}

=== debian/changelog ===
forkstat (0.02.00-1) unstable; urgency=medium

  * Makefile: update version and change codename
  * Minor tweaks to the manual, cosmetic changes
  * Move arrays to end of stacks to help avoid any stack smashing
  * Minor source clean-up
  * Avoid TOCTOU race on stat + open
  * Use alternative ptrace pid info
  * Add -x extra UID and TTY information option
  * Add uid/sid event tracing
  * Display name of events on -e option when invalid event used
  * Add ptrace event spying
  * Fix realtime flag opts mask
  * Fix -r help option
  * Add extra spacing in heading as it is offset by one after PID
  * Remove old set_priority code now that -r replaces it
  * Manpage: fix pdf warning:
  * Makefile: add pdf man page rule and add .PHONEYs
  * Add Philipp Gesang to the man page for kudos for contributions.
  * Add -r real time scheduling option
  * Put help options into one large printf statement

 -- Colin King <colin.king@canonical.com>  Sat, 24 Jun 2017 20:42:58 +0100

forkstat (0.01.19-1) unstable; urgency=medium

  * Makefile: bump version again
  * Debian/control: update standards version to 4.0.0
  * Update man page date
  * forkstat: add flag for line buffered output

 -- Colin King <colin.king@canonical.com>  Wed, 21 Jun 2017 17:51:15 +0100

forkstat (0.01.18-1) unstable; urgency=medium

  * Makefile: bump version
  * Only add proc_info if strtol parses pid correctly.
  * snapcraft: add default type and grade keys

 -- Colin King <colin.king@canonical.com>  Tue, 20 Jun 2017 10:01:27 +0100

forkstat (0.01.17-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: update copyright year and manual date
  * Makefile: add snapcraft to make dist rule
  * Add variable pid size handling.
  * Remove redundant free on a null pointer
  * Add snapcraft
  * Update copyright year
  * Manual: expand width of columns to 5i

 -- Colin King <colin.king@canonical.com>  Fri, 14 Apr 2017 17:37:57 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
 Uploaders: Kamal Mostafa <kamal@whence.com>
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Build-Depends: debhelper (>= 9)
 Homepage: http://kernel.ubuntu.com/~cking/forkstat

## forkstat 0.02.02

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2014-2017 Canonical, Ltd.
+# Copyright (C) 2014-2018 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.00
+VERSION=0.02.02
 #
 # Version "Perspicacious Process Peeker"
 #

=== snapcraft/Makefile ===
VERSION=$(shell git tag | tail -1 | cut -c2-)
COMMITS=$(shell git log --oneline | wc -l)
SHA=$(shell git log -1 --oneline | cut -d' ' -f1)
DATE=$(shell date +'%Y%m%d')
V=$(VERSION)-$(DATE)-$(COMMITS)-$(SHA)

all: get_icon set_version
	snapcraft

set_version:
	cat snapcraft.yaml | sed 's/version: .*/version: $(V)/' > snapcraft-tmp.yaml
	mv snapcraft-tmp.yaml snapcraft.yaml

get_icon: 
	@if [ ! -e setup/gui/icon.svg ]; \
	then \
		echo copying icon.svg; \
		mkdir -p setup/gui; \
		cp ../mascot/forkstat.svg setup/gui/icon.svg; \
	fi;

clean:
	rm -rf setup *.snap
	snapcraft clean
	cat snapcraft.yaml | sed 's/version: .*/version: 0/' > snapcraft-tmp.yaml
	mv snapcraft-tmp.yaml snapcraft.yaml

=== debian/changelog ===
forkstat (0.02.02-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: update Standards-Version to 4.1.2
  * ensure tty string never overflows, fixes gcc warning
  * include <sys/uio.h> to fix clang warning
  * Add -x option into mini help

 -- Colin King <colin.king@canonical.com>  Thu, 4 Jan 2018 22:53:12 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
 Uploaders: Kamal Mostafa <kamal@whence.com>
-Standards-Version: 4.0.0
+Standards-Version: 4.1.2
 Build-Depends: debhelper (>= 9)
 Homepage: http://kernel.ubuntu.com/~cking/forkstat

## forkstat 0.02.06

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.02
+VERSION=0.02.06
 #
 # Version "Perspicacious Process Peeker"
 #
@@ -48,8 +48,8 @@
 	rm -rf forkstat-$(VERSION)
 	mkdir forkstat-$(VERSION)
 	cp -rp Makefile forkstat.c forkstat.8 mascot COPYING \
-		snapcraft forkstat-$(VERSION)
-	tar -zcf forkstat-$(VERSION).tar.gz forkstat-$(VERSION)
+		snap .travis.yml forkstat-$(VERSION)
+	tar -Jcf forkstat-$(VERSION).tar.xz forkstat-$(VERSION)
 	rm -rf forkstat-$(VERSION)
 
 .PHONEY: pdf
@@ -59,7 +59,7 @@
 .PHONEY: clean
 clean:
 	rm -f forkstat forkstat.o forkstat.8.gz
-	rm -f forkstat-$(VERSION).tar.gz
+	rm -f forkstat-$(VERSION).tar.xz
 	rm -f forkstat.pdf
 
 .PHONEY: install

=== debian/changelog ===
forkstat (0.02.06-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: rename snapcraft to snap in dist rule
  * Add some extra paranoid clearing of tty and strncpy length,
    fixes potential buffer overrun
  * Remove some extraneous tabs
  * Add some extra function comments
  * Add caching of dev to tty name lookup to fix expensive lookups
  * Add caching of uid to name lookup, print username rather than uids
    to fix expensive lookups
  * forkstat: pack structs a little more efficiently to save memory
  * Fix typo in comment
  * Move snapcraft directory to snap

 -- Colin King <colin.king@canonical.com>  Wed, 26 Sep 2018 09:48:11 +0100

forkstat (0.02.05-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual, change -e all to -E in example to show alternate form
  * Reformat some lines, comments and overly wide scanf
  * Minor code clean ups
  * Ensure all fields in no_info are initialized
  * Manual: Fix process table information formatting
  * Voidify function returns
  * Add more constifications
  * Add -E (enable all events) option
  * PROC_EVENT_COREDUMP has been introduced in kernel version 3.10
  * Replace curved corner glyph with square corner

 -- Colin King <colin.king@canonical.com>  Fri, 13 Jul 2018 07:49:44 +0100

forkstat (0.02.04-1) unstable; urgency=medium

  * Makefile: bump version
  * Add .travis.yml to make dist rule
  * Makefile + debian/watch: produce a .xz tarball
  * Fix checking on zero sized reads
  * Add detection of first time all alive processes were started
  * Use UTF-16 codes for glyphs
  * Add travis build yaml file

 -- Colin King <colin.king@canonical.com>  Tue, 10 Jul 2018 13:32:23 +0100

forkstat (0.02.03-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: update debhelper to >= 11
  * debian/compat: update to 11
  * debian/copyright: replace http with https for secure URL
  * debian/control: remove trailing line
  * Add -g option to mini-help
  * Add -g glyph annotations
  * Add faster container check for systemd based systems
  * Add snapcraft plugins

 -- Colin King <colin.king@canonical.com>  Fri, 8 Jun 2018 16:16:17 +0000

## forkstat 0.02.09

=== Makefile ===
--- 
+++ 
@@ -16,12 +16,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.06
+VERSION=0.02.09
 #
 # Version "Perspicacious Process Peeker"
 #
 
-CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
+CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -g
 #
 # Pedantic flags
 #

=== debian/changelog ===
forkstat (0.02.09-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: update date
  * Add -X option, fix up short getopts help with missing options
  * forkstat: add in -c option in help info

 -- Colin King <colin.king@canonical.com>  Tue, 4 Dec 2018 11:11:11 +0000

forkstat (0.02.08-1) unstable; urgency=medium

  * Makefile: bump version
  * Reduce scope of pointer ptr
  * Use unsigned int for %u format specifiers
  * Update date in manual
  * Add -c comm field info, also track comm field changes in proc info

 -- Colin King <colin.king@canonical.com>  Sat, 1 Dec 2018 11:13:14 +0000

forkstat (0.02.07-1) unstable; urgency=medium

  * Makefile: bump version
  * remove '\r' and '\n' from command line process name

 -- Colin King <colin.king@canonical.com>  Tue, 20 Nov 2018 15:12:01 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Colin King <colin.king@canonical.com>
 Uploaders: Kamal Mostafa <kamal@whence.com>
 Standards-Version: 4.1.2
-Build-Depends: debhelper (>= 9)
+Build-Depends: debhelper (>= 11)
 Homepage: http://kernel.ubuntu.com/~cking/forkstat
 
 Package: forkstat
@@ -15,4 +15,3 @@
  It is useful for monitoring system behaviour and to track down
  rogue processes that are spawning off processes and potentially
  abusing the system.
-

=== debian/watch ===
version=3
http://kernel.ubuntu.com/~cking/tarballs/forkstat/forkstat-(.+).tar.xz

## forkstat 0.02.11

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2014-2018 Canonical, Ltd.
+# Copyright (C) 2014-2019 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.09
+VERSION=0.02.11
 #
 # Version "Perspicacious Process Peeker"
 #

=== debian/changelog ===
forkstat (0.02.11-1) unstable; urgency=medium

  * Makefile: bump version
  * Debian: update compat to 12
  * fix off-by-one end of string strncpy bug in tty name copying
  * snapcraft: make versioning automatic

 -- Colin King <colin.king@canonical.com>  Mon, 12 Aug 2019 14:15:16 +0100

forkstat (0.02.10-1) unstable; urgency=medium

  * Makefile: bump version
  * Fix spelling mistake in manual
  * Update copyright year

 -- Colin King <colin.king@canonical.com>  Sat, 6 Jul 2019 22:38:22 +0100

## forkstat 0.02.14

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2014-2019 Canonical, Ltd.
+# Copyright (C) 2014-2020 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.11
+VERSION=0.02.14
 #
 # Version "Perspicacious Process Peeker"
 #
@@ -36,6 +36,7 @@
 
 BINDIR=/usr/bin
 MANDIR=/usr/share/man/man8
+BASHDIR=/usr/share/bash-completion/completions
 
 forkstat: forkstat.o
 	$(CC) $(CPPFLAGS) $(CFLAGS) $< -o $@ $(LDFLAGS)
@@ -48,7 +49,7 @@
 	rm -rf forkstat-$(VERSION)
 	mkdir forkstat-$(VERSION)
 	cp -rp Makefile forkstat.c forkstat.8 mascot COPYING \
-		snap .travis.yml forkstat-$(VERSION)
+		snap .travis.yml bash-completion forkstat-$(VERSION)
 	tar -Jcf forkstat-$(VERSION).tar.xz forkstat-$(VERSION)
 	rm -rf forkstat-$(VERSION)
 
@@ -68,3 +69,5 @@
 	cp forkstat ${DESTDIR}${BINDIR}
 	mkdir -p ${DESTDIR}${MANDIR}
 	cp forkstat.8.gz ${DESTDIR}${MANDIR}
+	mkdir -p ${DESTDIR}${BASHDIR}
+	cp bash-completion/forkstat  ${DESTDIR}${BASHDIR}

=== debian/changelog ===
forkstat (0.02.14-1) unstable; urgency=medium

  * Makefile: bump version
  * Add effictive user id (EUID) for -x option (Closes: #951340)

 -- Colin King <colin.king@canonical.com>  Fri, 28 Feb 2020 15:02:41 +0000

forkstat (0.02.13-1) unstable; urgency=medium

  * Makefile: bump version
  * Add bash completion
  * Update copyright to 2020

 -- Colin King <colin.king@canonical.com>  Wed, 26 Feb 2020 00:16:18 +0000

forkstat (0.02.12-1) unstable; urgency=medium

  * Makefile: bump version
  * Remove no-op free_proc_comm call on an unknown comm field
  * Return no info rather than NULL if proc_info_get returns NULL
  * Re-work unknown cmdline information

 -- Colin King <colin.king@canonical.com>  Fri, 13 Dec 2019 19:59:11 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Colin King <colin.king@canonical.com>
 Uploaders: Kamal Mostafa <kamal@whence.com>
 Standards-Version: 4.1.2
-Build-Depends: debhelper (>= 11)
+Build-Depends: debhelper (>= 12)
 Homepage: http://kernel.ubuntu.com/~cking/forkstat
 
 Package: forkstat

## forkstat 0.02.15

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.14
+VERSION=0.02.15
 #
 # Version "Perspicacious Process Peeker"
 #

=== debian/changelog ===
forkstat (0.02.15-1) unstable; urgency=medium

  * Makefile: bump version
  * Debian/control: update compat to 13, remove compat file,
    add Rules-Requires-Roo t rule
  * Zero ws struct to clear static analysis warnings

 -- Colin King <colin.king@canonical.com>  Sat, 4 Jul 2020 11:16:22 +0100

## forkstat 0.02.16

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.15
+VERSION=0.02.16
 #
 # Version "Perspicacious Process Peeker"
 #

=== debian/changelog ===
forkstat (0.02.16-1) unstable; urgency=medium

  * Makefile: bump version
  * forkstat: handle weird comm field in /proc/$PID/stat
  * conditionally build in helper functions
  * only declare variables when they are required
  * snapcraft: replace version-script with an override

 -- Colin King <colin.king@canonical.com>  Sat, 7 Nov 2020 16:09:23 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: forkstat
+Rules-Requires-Root: no
 Section: admin
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
-Uploaders: Kamal Mostafa <kamal@whence.com>
 Standards-Version: 4.1.2
-Build-Depends: debhelper (>= 12)
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (=13)
 Homepage: http://kernel.ubuntu.com/~cking/forkstat
 
 Package: forkstat

## forkstat 0.02.17

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #
-# Copyright (C) 2014-2020 Canonical, Ltd.
+# Copyright (C) 2014-2021 Canonical, Ltd.
+# Copyright (C) 2021 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -16,7 +17,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.16
+VERSION=0.02.17
 #
 # Version "Perspicacious Process Peeker"
 #
@@ -29,7 +30,7 @@
 CFLAGS += -Wabi -Wcast-qual -Wfloat-equal -Wmissing-declarations \
 	-Wmissing-format-attribute -Wno-long-long -Wpacked \
 	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
-	-Wno-missing-braces -Wno-sign-compare -Wno-multichar
+	-Wno-missing-braces -Wno-sign-compare -Wno-multichar -fanalyzer
 endif
 
 export DEB_BUILD_HARDENING=1
@@ -49,7 +50,7 @@
 	rm -rf forkstat-$(VERSION)
 	mkdir forkstat-$(VERSION)
 	cp -rp Makefile forkstat.c forkstat.8 mascot COPYING \
-		snap .travis.yml bash-completion forkstat-$(VERSION)
+		snap .travis.yml bash-completion README.md forkstat-$(VERSION)
 	tar -Jcf forkstat-$(VERSION).tar.xz forkstat-$(VERSION)
 	rm -rf forkstat-$(VERSION)

=== debian/changelog ===
forkstat (0.02.17-1) unstable; urgency=medium

  * Makefile: bump version
  * forkstat.c: Update copyright
  * Makefile: update copyright
  * Makefile: add README.md to dist rule
  * manual: update date, author email and copyright
  * debian/watch: update watch path for tarball, move to version 4
  * debian/copyright: Update copyright and git URL
  * debian/control: update author email address and project URL
  * Add README.md
  * snapcraft: add build architectures
  * snapcraft: update to core20
  * update copyright to 2021

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 15 Nov 2021 19:40:22 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Rules-Requires-Root: no
 Section: admin
 Priority: optional
-Maintainer: Colin King <colin.king@canonical.com>
-Standards-Version: 4.1.2
+Maintainer: Colin Ian King <colin.i.king@gmail.com>
+Standards-Version: 4.5.1
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13)
-Homepage: http://kernel.ubuntu.com/~cking/forkstat
+Homepage: https://github.com/ColinIanKing/forkstat
 
 Package: forkstat
 Architecture: linux-any

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk

%:
	dh $@

## forkstat 0.03.00

=== debian/changelog ===
forkstat (0.03.00-1) unstable; urgency=medium

  * Makefile: bump version to 0.03.00
  * Debian/control: update standards version to 4.6.1
  * Remove redundant null check on ptr
  * Update copyright
  * forkstat: remove redundant assignment to ptr
  * Add STAT_NONE to event_t enum and use it instead of 0

 -- Colin Ian King <colin.i.king@gmail.com>  Tue, 6 Dec 2022 12:12:12 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13)
 Homepage: https://github.com/ColinIanKing/forkstat

## forkstat 0.03.01

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2014-2021 Canonical, Ltd.
-# Copyright (C) 2021 Colin Ian King
+# Copyright (C) 2021-2023 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -17,7 +17,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.02.17
+VERSION=0.03.01
 #
 # Version "Perspicacious Process Peeker"
 #

=== debian/changelog ===
forkstat (0.03.01-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: update standards version to 4.6.2
  * Manual: update copyright
  * forkstat: add -p process group id filtering option
  * forkstat: handle empty arg in argv[], replace with ' '
  * forkstat: make cmdline buffer 64K, allocate on heap
  * Update copyright year

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 8 Feb 2023 15:50:57 +0000

## forkstat 0.03.02

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2014-2021 Canonical, Ltd.
-# Copyright (C) 2021-2023 Colin Ian King
+# Copyright (C) 2021-2024 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -17,7 +17,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.03.01
+VERSION=0.03.02
 #
 # Version "Perspicacious Process Peeker"
 #
@@ -50,7 +50,7 @@
 	rm -rf forkstat-$(VERSION)
 	mkdir forkstat-$(VERSION)
 	cp -rp Makefile forkstat.c forkstat.8 mascot COPYING \
-		snap .travis.yml bash-completion README.md forkstat-$(VERSION)
+		.travis.yml bash-completion README.md forkstat-$(VERSION)
 	tar -Jcf forkstat-$(VERSION).tar.xz forkstat-$(VERSION)
 	rm -rf forkstat-$(VERSION)

=== debian/changelog ===
forkstat (0.03.02-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: remove snap from make dist rule
  * debian/rules: update hardening flags
  * Update copyright to 2024
  * Check for array bounds limit while parsing pid length string
  * Remove snapcraft
  * README.md: add repology link

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 12 Jan 2024 09:20:11 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13)
 Homepage: https://github.com/ColinIanKing/forkstat

## forkstat 0.04.00

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2014-2021 Canonical, Ltd.
-# Copyright (C) 2021-2024 Colin Ian King
+# Copyright (C) 2021-2025 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -17,7 +17,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.03.02
+VERSION=0.04.00
 #
 # Version "Perspicacious Process Peeker"
 #
@@ -35,9 +35,10 @@
 
 export DEB_BUILD_HARDENING=1
 
-BINDIR=/usr/bin
-MANDIR=/usr/share/man/man8
-BASHDIR=/usr/share/bash-completion/completions
+PREFIX=/usr
+BINDIR=$(PREFIX)/bin
+MANDIR=$(PREFIX)/share/man/man8
+BASHDIR=$(PREFIX)/share/bash-completion/completions
 
 forkstat: forkstat.o
 	$(CC) $(CPPFLAGS) $(CFLAGS) $< -o $@ $(LDFLAGS)

=== debian/changelog ===
forkstat (0.04.00-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: minor tweaks for lintian clean builds
  * Manual: rework table headings
  * debian/control: update standards version to 4.7.2
  * Add support for PROC_EVENT_NONZERO_EXIT events

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 16 Apr 2025 09:50:24 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13)
 Homepage: https://github.com/ColinIanKing/forkstat

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

%:
	dh $@
